<template>
  <span>
    {{ time }}

    <JText
      v-if="isUpdatedMessage && hideUpdatedLabel === false"
      type="text-4"
      color="text"
      weight="normal"
    >
      <i> {{ $t('edited') }} </i>
    </JText>
  </span>
</template>

<script setup lang="ts">
import { PropType, computed } from 'vue';
import { JText } from '@new-jira-clone/ui/src/components';
import { formatTo } from '@new-jira-clone/libs/src/utils/date/format-to';
import { IMessage } from '@/shared';

const props = defineProps({
  message: {
    type: Object as PropType<IMessage>,
    required: true,
  },
  onlyFormat: {
    type: Boolean,
    default: false,
  },
  hideUpdatedLabel: {
    type: Boolean,
    default: false,
  },
});

const isUpdatedMessage = computed(() => {
  const messageCreatedAt = new Date(props.message.createdAt ?? '');
  const messageUpdatedAt = new Date(props.message.updatedAt ?? '');

  return messageUpdatedAt > messageCreatedAt;
});

const time = computed(() => {
  if (!props.message.updatedAt) return '';

  const messageCreatedAt = new Date(props.message.createdAt);

  if (props.onlyFormat) {
    return formatTo(messageCreatedAt);
  }

  const dateNow = new Date();

  if (messageCreatedAt.toLocaleDateString() !== dateNow.toLocaleDateString()) {
    return messageCreatedAt.toLocaleDateString();
  }

  return formatTo(messageCreatedAt);
});
</script>
